use std :: os :: raw :: { c_char , c_void } ; const NULLPTR : * const c_void = 0 as * const c_void ; static mut types_null : [* const sys :: common :: wl_interface ; 4] = [NULLPTR as * const sys :: common :: wl_interface , NULLPTR as * const sys :: common :: wl_interface , NULLPTR as * const sys :: common :: wl_interface , NULLPTR as * const sys :: common :: wl_interface ,] ; # [doc = "virtual keyboard\n\nThe virtual keyboard provides an application with requests which emulate\nthe behaviour of a physical keyboard.\n\nThis interface can be used by clients on its own to provide raw input\nevents, or it can accompany the input method protocol."] pub mod zwp_virtual_keyboard_v1 { use std :: os :: raw :: c_char ; use super :: { Proxy , AnonymousObject , Interface , MessageGroup , MessageDesc , ArgumentType , Object , Message , Argument , ObjectMetadata , types_null , NULLPTR , Main , smallvec , } ; use super :: sys :: common :: { wl_interface , wl_array , wl_argument , wl_message } ; use super :: sys :: client :: * ; # [repr (u32)] # [derive (Copy , Clone , Debug , PartialEq)] # [non_exhaustive] pub enum Error { # [doc = "No keymap was set"] NoKeymap = 0 , } impl Error { pub fn from_raw (n : u32) -> Option < Error > { match n { 0 => Some (Error :: NoKeymap) , _ => Option :: None } } pub fn to_raw (& self) -> u32 { * self as u32 } } # [derive (Debug)] # [non_exhaustive] pub enum Request { # [doc = "keyboard mapping\n\nProvide a file descriptor to the compositor which can be\nmemory-mapped to provide a keyboard mapping description.\n\nFormat carries a value from the keymap_format enumeration."] Keymap { format : u32 , fd : :: std :: os :: unix :: io :: RawFd , size : u32 , } , # [doc = "key event\n\nA key was pressed or released.\nThe time argument is a timestamp with millisecond granularity, with an\nundefined base. All requests regarding a single object must share the\nsame clock.\n\nKeymap must be set before issuing this request.\n\nState carries a value from the key_state enumeration."] Key { time : u32 , key : u32 , state : u32 , } , # [doc = "modifier and group state\n\nNotifies the compositor that the modifier and/or group state has\nchanged, and it should update state.\n\nThe client should use wl_keyboard.modifiers event to synchronize its\ninternal state with seat state.\n\nKeymap must be set before issuing this request."] Modifiers { mods_depressed : u32 , mods_latched : u32 , mods_locked : u32 , group : u32 , } , # [doc = "destroy the virtual keyboard keyboard object\n\n\n\nThis is a destructor, once sent this object cannot be used any longer."] Destroy , } impl super :: MessageGroup for Request { const MESSAGES : & 'static [super :: MessageDesc] = & [super :: MessageDesc { name : "keymap" , since : 1 , signature : & [super :: ArgumentType :: Uint , super :: ArgumentType :: Fd , super :: ArgumentType :: Uint ,] , destructor : false , } , super :: MessageDesc { name : "key" , since : 1 , signature : & [super :: ArgumentType :: Uint , super :: ArgumentType :: Uint , super :: ArgumentType :: Uint ,] , destructor : false , } , super :: MessageDesc { name : "modifiers" , since : 1 , signature : & [super :: ArgumentType :: Uint , super :: ArgumentType :: Uint , super :: ArgumentType :: Uint , super :: ArgumentType :: Uint ,] , destructor : false , } , super :: MessageDesc { name : "destroy" , since : 1 , signature : & [] , destructor : true , } ,] ; type Map = super :: ProxyMap ; fn is_destructor (& self) -> bool { match * self { Request :: Destroy => true , _ => false , } } fn opcode (& self) -> u16 { match * self { Request :: Keymap { .. } => 0 , Request :: Key { .. } => 1 , Request :: Modifiers { .. } => 2 , Request :: Destroy => 3 , } } fn since (& self) -> u32 { match * self { Request :: Keymap { .. } => 1 , Request :: Key { .. } => 1 , Request :: Modifiers { .. } => 1 , Request :: Destroy => 1 , } } fn child < Meta : ObjectMetadata > (opcode : u16 , version : u32 , meta : & Meta) -> Option < Object < Meta >> { match opcode { _ => None , } } fn from_raw (msg : Message , map : & mut Self :: Map) -> Result < Self , () > { panic ! ("Request::from_raw can not be used Client-side.") } fn into_raw (self , sender_id : u32) -> Message { match self { Request :: Keymap { format , fd , size } => Message { sender_id : sender_id , opcode : 0 , args : smallvec ! [Argument :: Uint (format) , Argument :: Fd (fd) , Argument :: Uint (size) ,] , } , Request :: Key { time , key , state } => Message { sender_id : sender_id , opcode : 1 , args : smallvec ! [Argument :: Uint (time) , Argument :: Uint (key) , Argument :: Uint (state) ,] , } , Request :: Modifiers { mods_depressed , mods_latched , mods_locked , group } => Message { sender_id : sender_id , opcode : 2 , args : smallvec ! [Argument :: Uint (mods_depressed) , Argument :: Uint (mods_latched) , Argument :: Uint (mods_locked) , Argument :: Uint (group) ,] , } , Request :: Destroy => Message { sender_id : sender_id , opcode : 3 , args : smallvec ! [] , } , } } unsafe fn from_raw_c (obj : * mut :: std :: os :: raw :: c_void , opcode : u32 , args : * const wl_argument ,) -> Result < Request , () > { panic ! ("Request::from_raw_c can not be used Client-side.") } fn as_raw_c_in < F , T > (self , f : F) -> T where F : FnOnce (u32 , & mut [wl_argument]) -> T { match self { Request :: Keymap { format , fd , size } => { let mut _args_array : [wl_argument ; 3] = unsafe { :: std :: mem :: zeroed () } ; _args_array [0] . u = format ; _args_array [1] . h = fd ; _args_array [2] . u = size ; f (0 , & mut _args_array) } , Request :: Key { time , key , state } => { let mut _args_array : [wl_argument ; 3] = unsafe { :: std :: mem :: zeroed () } ; _args_array [0] . u = time ; _args_array [1] . u = key ; _args_array [2] . u = state ; f (1 , & mut _args_array) } , Request :: Modifiers { mods_depressed , mods_latched , mods_locked , group } => { let mut _args_array : [wl_argument ; 4] = unsafe { :: std :: mem :: zeroed () } ; _args_array [0] . u = mods_depressed ; _args_array [1] . u = mods_latched ; _args_array [2] . u = mods_locked ; _args_array [3] . u = group ; f (2 , & mut _args_array) } , Request :: Destroy => { let mut _args_array : [wl_argument ; 0] = unsafe { :: std :: mem :: zeroed () } ; f (3 , & mut _args_array) } , } } } # [derive (Debug)] # [non_exhaustive] pub enum Event { } impl super :: MessageGroup for Event { const MESSAGES : & 'static [super :: MessageDesc] = & [] ; type Map = super :: ProxyMap ; fn is_destructor (& self) -> bool { match * self { } } fn opcode (& self) -> u16 { match * self { } } fn since (& self) -> u32 { match * self { } } fn child < Meta : ObjectMetadata > (opcode : u16 , version : u32 , meta : & Meta) -> Option < Object < Meta >> { match opcode { _ => None , } } fn from_raw (msg : Message , map : & mut Self :: Map) -> Result < Self , () > { match msg . opcode { _ => Err (()) , } } fn into_raw (self , sender_id : u32) -> Message { panic ! ("Event::into_raw can not be used Client-side.") } unsafe fn from_raw_c (obj : * mut :: std :: os :: raw :: c_void , opcode : u32 , args : * const wl_argument ,) -> Result < Event , () > { match opcode { _ => return Err (()) , } } fn as_raw_c_in < F , T > (self , f : F) -> T where F : FnOnce (u32 , & mut [wl_argument]) -> T { panic ! ("Event::as_raw_c_in can not be used Client-side.") } } # [derive (Clone , Eq , PartialEq)] pub struct ZwpVirtualKeyboardV1 (Proxy < ZwpVirtualKeyboardV1 >) ; impl AsRef < Proxy < ZwpVirtualKeyboardV1 >> for ZwpVirtualKeyboardV1 { # [inline] fn as_ref (& self) -> & Proxy < Self > { & self . 0 } } impl From < Proxy < ZwpVirtualKeyboardV1 >> for ZwpVirtualKeyboardV1 { # [inline] fn from (value : Proxy < Self >) -> Self { ZwpVirtualKeyboardV1 (value) } } impl From < ZwpVirtualKeyboardV1 > for Proxy < ZwpVirtualKeyboardV1 > { # [inline] fn from (value : ZwpVirtualKeyboardV1) -> Self { value . 0 } } impl std :: fmt :: Debug for ZwpVirtualKeyboardV1 { fn fmt (& self , f : & mut std :: fmt :: Formatter < '_ >) -> std :: fmt :: Result { f . write_fmt (format_args ! ("{:?}" , self . 0)) } } impl Interface for ZwpVirtualKeyboardV1 { type Request = Request ; type Event = Event ; const NAME : & 'static str = "zwp_virtual_keyboard_v1" ; const VERSION : u32 = 1 ; fn c_interface () -> * const wl_interface { unsafe { & zwp_virtual_keyboard_v1_interface } } } impl ZwpVirtualKeyboardV1 { # [doc = "keyboard mapping\n\nProvide a file descriptor to the compositor which can be\nmemory-mapped to provide a keyboard mapping description.\n\nFormat carries a value from the keymap_format enumeration."] pub fn keymap (& self , format : u32 , fd : :: std :: os :: unix :: io :: RawFd , size : u32) -> () { let msg = Request :: Keymap { format : format , fd : fd , size : size } ; self . 0 . send :: < AnonymousObject > (msg , None) ; } # [doc = "key event\n\nA key was pressed or released.\nThe time argument is a timestamp with millisecond granularity, with an\nundefined base. All requests regarding a single object must share the\nsame clock.\n\nKeymap must be set before issuing this request.\n\nState carries a value from the key_state enumeration."] pub fn key (& self , time : u32 , key : u32 , state : u32) -> () { let msg = Request :: Key { time : time , key : key , state : state } ; self . 0 . send :: < AnonymousObject > (msg , None) ; } # [doc = "modifier and group state\n\nNotifies the compositor that the modifier and/or group state has\nchanged, and it should update state.\n\nThe client should use wl_keyboard.modifiers event to synchronize its\ninternal state with seat state.\n\nKeymap must be set before issuing this request."] pub fn modifiers (& self , mods_depressed : u32 , mods_latched : u32 , mods_locked : u32 , group : u32) -> () { let msg = Request :: Modifiers { mods_depressed : mods_depressed , mods_latched : mods_latched , mods_locked : mods_locked , group : group } ; self . 0 . send :: < AnonymousObject > (msg , None) ; } # [doc = "destroy the virtual keyboard keyboard object\n\n\n\nThis is a destructor, you cannot send requests to this object any longer once this method is called."] pub fn destroy (& self ,) -> () { let msg = Request :: Destroy ; self . 0 . send :: < AnonymousObject > (msg , None) ; } } # [doc = r" The minimal object version supporting this request"] pub const REQ_KEYMAP_SINCE : u32 = 1u32 ; # [doc = r" The minimal object version supporting this request"] pub const REQ_KEY_SINCE : u32 = 1u32 ; # [doc = r" The minimal object version supporting this request"] pub const REQ_MODIFIERS_SINCE : u32 = 1u32 ; # [doc = r" The minimal object version supporting this request"] pub const REQ_DESTROY_SINCE : u32 = 1u32 ; # [doc = r" C-representation of the messages of this interface, for interop"] pub static mut zwp_virtual_keyboard_v1_requests : [wl_message ; 4] = [wl_message { name : b"keymap\0" as * const u8 as * const c_char , signature : b"uhu\0" as * const u8 as * const c_char , types : unsafe { & types_null as * const _ } , } , wl_message { name : b"key\0" as * const u8 as * const c_char , signature : b"uuu\0" as * const u8 as * const c_char , types : unsafe { & types_null as * const _ } , } , wl_message { name : b"modifiers\0" as * const u8 as * const c_char , signature : b"uuuu\0" as * const u8 as * const c_char , types : unsafe { & types_null as * const _ } , } , wl_message { name : b"destroy\0" as * const u8 as * const c_char , signature : b"\0" as * const u8 as * const c_char , types : unsafe { & types_null as * const _ } , } ,] ; # [doc = r" C representation of this interface, for interop"] pub static mut zwp_virtual_keyboard_v1_interface : wl_interface = wl_interface { name : b"zwp_virtual_keyboard_v1\0" as * const u8 as * const c_char , version : 1 , request_count : 4 , requests : unsafe { & zwp_virtual_keyboard_v1_requests as * const _ } , event_count : 0 , events : NULLPTR as * const wl_message , } ; } # [doc = "virtual keyboard manager\n\nA virtual keyboard manager allows an application to provide keyboard\ninput events as if they came from a physical keyboard."] pub mod zwp_virtual_keyboard_manager_v1 { use std :: os :: raw :: c_char ; use super :: { Proxy , AnonymousObject , Interface , MessageGroup , MessageDesc , ArgumentType , Object , Message , Argument , ObjectMetadata , types_null , NULLPTR , Main , smallvec , } ; use super :: sys :: common :: { wl_interface , wl_array , wl_argument , wl_message } ; use super :: sys :: client :: * ; # [repr (u32)] # [derive (Copy , Clone , Debug , PartialEq)] # [non_exhaustive] pub enum Error { # [doc = "client not authorized to use the interface"] Unauthorized = 0 , } impl Error { pub fn from_raw (n : u32) -> Option < Error > { match n { 0 => Some (Error :: Unauthorized) , _ => Option :: None } } pub fn to_raw (& self) -> u32 { * self as u32 } } # [derive (Debug)] # [non_exhaustive] pub enum Request { # [doc = "Create a new virtual keyboard\n\nCreates a new virtual keyboard associated to a seat.\n\nIf the compositor enables a keyboard to perform arbitrary actions, it\nshould present an error when an untrusted client requests a new\nkeyboard."] CreateVirtualKeyboard { seat : super :: wl_seat :: WlSeat , } , } impl super :: MessageGroup for Request { const MESSAGES : & 'static [super :: MessageDesc] = & [super :: MessageDesc { name : "create_virtual_keyboard" , since : 1 , signature : & [super :: ArgumentType :: Object , super :: ArgumentType :: NewId ,] , destructor : false , } ,] ; type Map = super :: ProxyMap ; fn is_destructor (& self) -> bool { match * self { _ => false , } } fn opcode (& self) -> u16 { match * self { Request :: CreateVirtualKeyboard { .. } => 0 , } } fn since (& self) -> u32 { match * self { Request :: CreateVirtualKeyboard { .. } => 1 , } } fn child < Meta : ObjectMetadata > (opcode : u16 , version : u32 , meta : & Meta) -> Option < Object < Meta >> { match opcode { 0 => Some (Object :: from_interface :: < super :: zwp_virtual_keyboard_v1 :: ZwpVirtualKeyboardV1 > (version , meta . child () ,)) , _ => None , } } fn from_raw (msg : Message , map : & mut Self :: Map) -> Result < Self , () > { panic ! ("Request::from_raw can not be used Client-side.") } fn into_raw (self , sender_id : u32) -> Message { match self { Request :: CreateVirtualKeyboard { seat } => Message { sender_id : sender_id , opcode : 0 , args : smallvec ! [Argument :: Object (seat . as_ref () . id ()) , Argument :: NewId (0) ,] , } , } } unsafe fn from_raw_c (obj : * mut :: std :: os :: raw :: c_void , opcode : u32 , args : * const wl_argument ,) -> Result < Request , () > { panic ! ("Request::from_raw_c can not be used Client-side.") } fn as_raw_c_in < F , T > (self , f : F) -> T where F : FnOnce (u32 , & mut [wl_argument]) -> T { match self { Request :: CreateVirtualKeyboard { seat } => { let mut _args_array : [wl_argument ; 2] = unsafe { :: std :: mem :: zeroed () } ; _args_array [0] . o = seat . as_ref () . c_ptr () as * mut _ ; _args_array [1] . o = :: std :: ptr :: null_mut () as * mut _ ; f (0 , & mut _args_array) } , } } } # [derive (Debug)] # [non_exhaustive] pub enum Event { } impl super :: MessageGroup for Event { const MESSAGES : & 'static [super :: MessageDesc] = & [] ; type Map = super :: ProxyMap ; fn is_destructor (& self) -> bool { match * self { } } fn opcode (& self) -> u16 { match * self { } } fn since (& self) -> u32 { match * self { } } fn child < Meta : ObjectMetadata > (opcode : u16 , version : u32 , meta : & Meta) -> Option < Object < Meta >> { match opcode { _ => None , } } fn from_raw (msg : Message , map : & mut Self :: Map) -> Result < Self , () > { match msg . opcode { _ => Err (()) , } } fn into_raw (self , sender_id : u32) -> Message { panic ! ("Event::into_raw can not be used Client-side.") } unsafe fn from_raw_c (obj : * mut :: std :: os :: raw :: c_void , opcode : u32 , args : * const wl_argument ,) -> Result < Event , () > { match opcode { _ => return Err (()) , } } fn as_raw_c_in < F , T > (self , f : F) -> T where F : FnOnce (u32 , & mut [wl_argument]) -> T { panic ! ("Event::as_raw_c_in can not be used Client-side.") } } # [derive (Clone , Eq , PartialEq)] pub struct ZwpVirtualKeyboardManagerV1 (Proxy < ZwpVirtualKeyboardManagerV1 >) ; impl AsRef < Proxy < ZwpVirtualKeyboardManagerV1 >> for ZwpVirtualKeyboardManagerV1 { # [inline] fn as_ref (& self) -> & Proxy < Self > { & self . 0 } } impl From < Proxy < ZwpVirtualKeyboardManagerV1 >> for ZwpVirtualKeyboardManagerV1 { # [inline] fn from (value : Proxy < Self >) -> Self { ZwpVirtualKeyboardManagerV1 (value) } } impl From < ZwpVirtualKeyboardManagerV1 > for Proxy < ZwpVirtualKeyboardManagerV1 > { # [inline] fn from (value : ZwpVirtualKeyboardManagerV1) -> Self { value . 0 } } impl std :: fmt :: Debug for ZwpVirtualKeyboardManagerV1 { fn fmt (& self , f : & mut std :: fmt :: Formatter < '_ >) -> std :: fmt :: Result { f . write_fmt (format_args ! ("{:?}" , self . 0)) } } impl Interface for ZwpVirtualKeyboardManagerV1 { type Request = Request ; type Event = Event ; const NAME : & 'static str = "zwp_virtual_keyboard_manager_v1" ; const VERSION : u32 = 1 ; fn c_interface () -> * const wl_interface { unsafe { & zwp_virtual_keyboard_manager_v1_interface } } } impl ZwpVirtualKeyboardManagerV1 { # [doc = "Create a new virtual keyboard\n\nCreates a new virtual keyboard associated to a seat.\n\nIf the compositor enables a keyboard to perform arbitrary actions, it\nshould present an error when an untrusted client requests a new\nkeyboard."] pub fn create_virtual_keyboard (& self , seat : & super :: wl_seat :: WlSeat) -> Main < super :: zwp_virtual_keyboard_v1 :: ZwpVirtualKeyboardV1 > { let msg = Request :: CreateVirtualKeyboard { seat : seat . clone () } ; self . 0 . send (msg , None) . unwrap () } } # [doc = r" The minimal object version supporting this request"] pub const REQ_CREATE_VIRTUAL_KEYBOARD_SINCE : u32 = 1u32 ; static mut zwp_virtual_keyboard_manager_v1_requests_create_virtual_keyboard_types : [* const wl_interface ; 2] = [unsafe { & super :: wl_seat :: wl_seat_interface as * const wl_interface } , unsafe { & super :: zwp_virtual_keyboard_v1 :: zwp_virtual_keyboard_v1_interface as * const wl_interface } ,] ; # [doc = r" C-representation of the messages of this interface, for interop"] pub static mut zwp_virtual_keyboard_manager_v1_requests : [wl_message ; 1] = [wl_message { name : b"create_virtual_keyboard\0" as * const u8 as * const c_char , signature : b"on\0" as * const u8 as * const c_char , types : unsafe { & zwp_virtual_keyboard_manager_v1_requests_create_virtual_keyboard_types as * const _ } , } ,] ; # [doc = r" C representation of this interface, for interop"] pub static mut zwp_virtual_keyboard_manager_v1_interface : wl_interface = wl_interface { name : b"zwp_virtual_keyboard_manager_v1\0" as * const u8 as * const c_char , version : 1 , request_count : 1 , requests : unsafe { & zwp_virtual_keyboard_manager_v1_requests as * const _ } , event_count : 0 , events : NULLPTR as * const wl_message , } ; }